import { AppBaseAction } from './app-base-action';
import { BaseEntityActions } from './entity-actions.enum';
import { ActionPayload } from './event-args/action-event-args';
export declare class DefaultLoad<T> extends AppBaseAction<T> {
    type: BaseEntityActions;
    constructor(url?: string);
}
export declare class DefaultLoadSuccess<T> extends AppBaseAction<ActionPayload<T>> {
    type: BaseEntityActions;
    constructor(data: any);
}
export declare class DefaultCreate<T> extends AppBaseAction<T> {
    type: BaseEntityActions;
    constructor(url: string, data: T);
}
export declare class DefaultCreateSuccess<T> extends AppBaseAction<T> {
    type: BaseEntityActions;
    constructor(data: ActionPayload<T>);
}
export declare class DefaultUpdate<T> extends AppBaseAction<T> {
    type: BaseEntityActions;
    constructor(url: string, data: T);
}
export declare class DefaultUpdateSuccess<T> extends AppBaseAction<T> {
    type: BaseEntityActions;
    constructor(data: ActionPayload<T>);
}
export declare class DefaultRemove<T> extends AppBaseAction<T> {
    type: BaseEntityActions;
    constructor(url: string, data: T);
}
export declare class DefaultRemoveSuccess<T> extends AppBaseAction<T> {
    type: BaseEntityActions;
    constructor(data: ActionPayload<T>);
}
export declare class DefaultError<T> extends AppBaseAction<T> {
    type: BaseEntityActions;
    constructor(error: T);
}
export declare type Actions<T> = DefaultLoad<T> | DefaultLoadSuccess<T> | DefaultCreate<T> | DefaultCreateSuccess<T> | DefaultUpdate<T> | DefaultUpdateSuccess<T> | DefaultRemove<T> | DefaultRemoveSuccess<T> | DefaultError<T>;
